<id>
Easy Referrals for YaBB 2.6.11
</id>

<version>
0.4
</version>

<mod info>
Description
-----------
Adds a simple referral feature as requested by Merv (westwegoman).

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.

Files to edit
-------------
Admin/ModList.pm
Languages/English/Email.lng
Languages/English/Profile.lng
Languages/English/Register.lng
Sources/Profile.pm
Sources/Register.pm
Sources/System.pm

Version History
---------------
0.1 - 8th August 2012
0.2 - Made referrers name on registration page case-insensitive - 9th August 2012
0.3 - Updated for YaBB 2.6.1 by Dandello
0.4 - Updated for YaBB 2.6.11 by Dandello - Dec 15, 2014
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.yabbforumsoftware.com.net/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
Admin/Modlist.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $easy_referral_mod = 'Easy Referrals|Derek Barnstorm|Adds a simple referral feature as requested by Merv (westwegoman). (Updated for 2.6.11 by Dandello)|0.4|15th December 2014';
    push @installed_mods, $easy_referral_mod;

</add before>

<edit file>
Languages/English/Email.lng
</edit file>

<search for>
User E-mail: {yabb useremail}
</search for>

<add after>
Referrer: {yabb referrer}
</add after>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
1;
</search for>

<add before>
$profile_txt{'referrer'} = 'Referred by';

</add before>

<edit file>
Languages/English/Register.lng
</edit file>

<search for>
1;
</search for>

<add before>
$register_txt{'referrer'} = 'Referrer';
$register_txt{'referrer_desc'} = 'If you were referred to this forum by an existing member,<br /> please enter their user ID or screen name here.';
$register_txt{'referrer_not_found'} = q~The referrer's name does not exist on this forum.~;

</add before>

<edit file>
Templates/default/MyProfile.template
</edit file>

<search for>
                {yabb dr}<br /><b>{yabb member_for_days}</b> $profile_txt{'894'}
            </div>
</search for>

<add after>
{yabb referrer}
</add after>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
    # End statistics.
</search for>

<add after>
    if (${$uid.$user}{'referrer'}) {
        $refname = ${$uid.$user}{'referrer'};
        LoadUser($refname);
        $member_referrers = qq~
            <div class="contactleft">
            <b>$profile_txt{'referrer'}: </b>
            </div>
            <div class="contactright">
            <b>$link{$refname}</b>
            </div>~;
    }
 </add after>

<search for>
## Mod Hook showProfile2 ##
</search for>

<add after>
    $showProfile =~ s/{yabb referrer}/$member_referrers/sm;
</add after>

<edit file>
Sources/Register.pm
</edit file>

<search for>
            $yymain =~ s/{yabb addmemgroup}/$addmemgroup/sm;
        }
    }
</search for>

<add after>
    $yymain .= $my_referrer;
</add after>

<search for>
    if ( $member{'reason'} eq q{} && $regtype == 1 ) {
        fatal_error('no_reg_reason');
    }
</search for>

<add after>

    # Check that the referrer exists
    if ($member{'referrer'}) {
        ManageMemberinfo('load');
        while (($membername, $value) = each(%memberinf)) {
            ($displayed_name, undef, undef, undef, undef) = split /\|/xsm, $value;
            if (lc $member{'referrer'} eq lc $displayed_name) { $member{'referrer'} = $membername; }
            if (lc $member{'referrer'} eq lc $membername) { $refname = $membername; }
        }
        undef %memberinf;
        if (lc $member{'referrer'} ne lc $refname) { fatal_error('', "$register_txt{'referrer_not_found'}"); }
        else { $member{'referrer'} = $refname; }
    }
</add after>

<search for>
    ${ $uid . $reguser }{'pageindex'}  = q~1|1|1|1~;
</search for>

<add after>
    ${ $uid . $reguser }{'referrer'} = $member{'referrer'};
</add after>

<search for>
            sendmail(
                $new_member_notification_mail,
                $mailreg_txt{'new_member_info'},
                template_email(
                    $newmemberemail,
                    {
                        'displayname' => $member{'regrealname'},
                        'username'    => $reguser,
                        'userip'      => $user_ip,
                        'useremail'   => ${ $uid . $reguser }{'email'}
                    }
                ),
                q{},
                $emailcharset
            );
</search for>

<replace>
            if (${ $uid . $reguser }{'referrer'}) {
                $refname = ${ $uid . $reguser }{'referrer'};
                LoadUser($refname);
                $ref_name = ${ $uid . $refname }{'realname'};
            } else {
                $ref_name = $maintxt{'470'};
            }
            sendmail(
                $new_member_notification_mail,
                $mailreg_txt{'new_member_info'},
                template_email(
                    $newmemberemail,
                    {
                        'displayname' => $member{'regrealname'},
                        'username'    => $reguser,
                        'userip'      => $user_ip,
                        'useremail'   => ${ $uid . $reguser }{'email'},
                        'referrer' => $ref_name
                    }
                ),
                q{},
                $emailcharset
            );
 </replace>

<edit file>
Sources/System.pm
</edit file>

<search for>
   ## Mod hook ##
</search for>

<add before>
    push @tags, 'referrer';
</add before>

<edit file>
Templates/default/Register.template
</edit file>

<search for>
1;
</search for>

<add before>
    $my_referrer = qq~<tr>
        <td class="windowbg right vtop">
            <label for="referrer"><b>$register_txt{'referrer'}:</b>
            <br /><span class="small">$register_txt{'referrer_desc'}</span></label>
        </td>
        <td class="windowbg2 vtop">
            <input type="text" name="referrer" id="referrer" size="30" maxlength="30" />
        </td>
    </tr>~;
</add before>
